Attribute VB_Name = "Arrays"
Option Explicit

'-------------------------------------------------------------------------------------------------------
'                                 ## MDULO DE CDIGO: ARRAYS ##
'
' OBJETIVO: CONTENER EL CONJUNTO DE PROCEDIMIENTOS Y FUNCIONES NECESARIAS PARA LA GESTIN DE LOS
'           DISTINTOS VECTORES Y MATRICES QUE SE MANIPULAN EN RESTANTES MDULO DE CDIGO.
'-------------------------------------------------------------------------------------------------------


'**************************************************************************************************
'   PROCEDIMIENTO: IgualarLimitesVectores()
'**************************************************************************************************
Public Sub IgualarLimitesVectores(CDAX() As Double, CDAY() As Double, CDBX() As Double, CDBY() As Double)
  Dim MSub1 As Integer, MSub2 As Integer
  
  If CDAX(0) < CDBX(0) Then
    CDBX(0) = CDAX(0)
    'CDBY(0) = CDAY(0)
  ElseIf CDAX(0) > CDBX(0) Then
    CDAX(0) = CDBX(0)
    'CDAY(0) = CDBY(0)
  End If
  
  MSub1 = UBound(CDAX(), 1)
  MSub2 = UBound(CDBX(), 1)
  
  If CDAX(MSub1) > CDBX(MSub2) Then
    CDBX(MSub2) = CDAX(MSub1)
    'CDBY(MSub2) = CDAY(MSub1)
  ElseIf CDAX(MSub1) < CDBX(MSub2) Then
    CDAX(MSub1) = CDBX(MSub2)
    'CDAY(MSub1) = CDBY(MSub2)
  End If

End Sub



'**************************************************************************************************
'   PROCEDIMIENTO: IntroducirValorMatriz()
'**************************************************************************************************
Public Sub IntroducirValorMatriz(MatrizX() As Double, ValorX As Double, MatrizY() As Double, ValorY As Double)
  On Error Resume Next
  Dim Id As Integer
  
  Id = UBound(MatrizX())
  If Err.Number = 9 Then
    Id = 0
    Err.Clear
    ReDim MatrizX(Id)
    ReDim MatrizY(Id)
    MatrizX(Id) = ValorX
    MatrizY(Id) = ValorY
  Else
    If MatrizX(Id) < ValorX Then
        ReDim Preserve MatrizX(Id + 1)
        ReDim Preserve MatrizY(Id + 1)
        MatrizX(Id + 1) = ValorX
        MatrizY(Id + 1) = ValorY
    End If
  End If
  
End Sub
'**************************************************************************************************
'   PROCEDIMIENTO: IntroducirValoresMatrizAenB()
'**************************************************************************************************
Public Sub IntroducirValoresMatrizAenB(MatrizA() As Double, MatrizB() As Double)
  On Error Resume Next
  Dim MSubA As Integer, I As Integer
  
  MSubA = UBound(MatrizA())
  If Err.Number = 9 Then
    Exit Sub
  Else
    ReDim MatrizB(MSubA)
    For I = 0 To MSubA
      MatrizB(I) = MatrizA(I)
    Next I
  End If
  
End Sub

'**************************************************************************************************
'   PROCEDIMIENTO: SepararCoordXY()
'**************************************************************************************************
Public Sub SepararCoordXY(VectorXY() As Double, VectorX() As Double, VectorY() As Double)
  
  On Error Resume Next
  Dim MSub As Integer, I As Integer, j As Integer
  
  MSub = UBound(VectorXY(), 1)
  If Err.Number = 9 Then
    Err.Clear
    MSub = 0
  End If
  
  ReDim VectorX(MSub \ 2)
  ReDim VectorY(MSub \ 2)
  j = 0
  
  For I = 0 To MSub - 1 Step 2
    VectorX(j) = VectorXY(I)
    VectorY(j) = VectorXY(I + 1)
    j = j + 1
  Next I

End Sub

'**************************************************************************************************
'   PROCEDIMIENTO: UnirCoordXY()
'**************************************************************************************************
Public Sub UnirCoordXY(VectorX() As Double, VectorY() As Double, VectorXY() As Double)
  
  On Error Resume Next
  Dim MSub As Integer, I As Integer, j As Integer
  
  MSub = UBound(VectorX(), 1)
  If Err.Number = 9 Then
    Err.Clear
    MSub = 0
  End If

  ReDim VectorXY(2 * MSub)
  j = 0
  For I = 0 To MSub
    VectorXY(j) = VectorX(I)
    VectorXY(j + 1) = VectorY(I)
    j = j + 1
  Next I
  
End Sub


