Attribute VB_Name = "Files"

'-------------------------------------------------------------------------------------------------------
'                                 ## MDULO DE CDIGO: FILES.BAS ##
'
' OBJETIVO: Contener el cdigo necesario para gestionar la lectura/almacenamiento de informacin
'           estructurada de los archivos especficos de la aplicacin.
'
'-------------------------------------------------------------------------------------------------------
Option Explicit

'---------------------------------
' - DECLARACIN DE ENUMERACIONES -
'---------------------------------
Public Enum ETBUSQUEDANUMEROS
    Ordenada = 0
    OrdenadaSinLimites = 1
    Desordenada = 2
    DesordenadaSinLimites = 3
    Extendida = 4
End Enum

'---------------------------------
' -- DECLARACIN DE CONSTANTES --
'---------------------------------
Public Const ABREVIAT_CONJDIF = "CD"
Public Const ABREVIAT_ANTECED = "ANT"
Public Const ABREVIAT_CONSEC = "CON"
Public Const GUION = "_"

Public Const SECCION_PLANTILLA = "PLANTILLA"
Public Const SECCION_GENERAL = "GENERAL"
Public Const SECCION_ENTRADA = "E"
Public Const SECCION_SALIDA = "S"
Public Const SECCION_REGLA = "R"
Public Const SECCION_MOTOR = "MOTOR DE INFERENCIA"

'CLAVES SECCIN PLANTILLA
Public Const CLAVE_PLANTILLA = "Descripcin"

'CLAVES SECCIN GENERAL
Public Const CLAVE_USUARIO = "Usuario"
Public Const CLAVE_TITULO = "Ttulo"
Public Const CLAVE_OBSERVACIONES = "Observaciones"
Public Const CLAVE_NENTRADAS = "NumEntradas"
Public Const CLAVE_NSALIDAS = "NumSalidas"
Public Const CLAVE_NREGLAS = "NumReglas"


'CLAVES SECCIN ENTRADA o SALIDA
Public Const CLAVE_ESTADO = "Estado"
Public Const CLAVE_NOMBRE = "Nombre"
Public Const CLAVE_UNIDADES = "Unidades"
Public Const CLAVE_UNDSIGLA = "UndSigla"
Public Const CLAVE_UNIVDISC = "UniversoDiscurso"
Public Const CLAVE_NOMSECUENCIA = "Secuencia"
Public Const CLAVE_NVCRISPS = "NumVCrisps"
Public Const CLAVE_VCRIPS = "VCrisps"
Public Const CLAVE_DIFUSOR = "Difusor"
Public Const CLAVE_PBASICOS = "PBasicos"


Public Const CLAVE_NPEXTENDIDOS = "NumPExtendidos"
Public Const CLAVE_PEXTENDIDOS = "PExtendidos"
Public Const CLAVE_NCONJDIF = "NumConjDifusos"
Public Const CLAVE_ETIQUETA = "Etiqueta"
Public Const CLAVE_TIPO = "Tipo"
Public Const CLAVE_CONCRESOR = "Concresor"


'CLAVES SECCIN REGLA
Public Const CLAVE_OPERADOR = "Operador"
Public Const CLAVE_NANT = "NumAntecedentes"
Public Const CLAVE_NCONS = "NumConsecuentes"
Public Const CLAVE_ACTIVO = "Activo"
Public Const CLAVE_ENTRADA = "Entrada"
Public Const CLAVE_SALIDA = "Salida"
Public Const CLAVE_OPNOT = "OpNot"

'CLAVES SECCIN MOTOR
Public Const CLAVE_OPIMPLICACION = "OpImplicacion"
Public Const CLAVE_OPAGREGACION = "OpAgregacion"
Public Const CLAVE_P_OPAG = "OpAg-P"
Public Const CLAVE_OPANDTNORMA = "OpAND"
Public Const CLAVE_P_OPAND = "OpAnd-P"
Public Const CLAVE_OPORSNORMA = "OpOR"
Public Const CLAVE_P_OPOR = "OpOr-P"
Public Const CLAVE_OPDIFUMINACION = "OpDifuminacion"
Public Const CLAVE_P_OPDF = "OpDf-P"


'**************************************************************************************************
'   PROCEDIMIENTO: GuardarDatoSistema()
'
'       OBJETIVO: Almacenar la informacin de forma estructurada.
'
'**************************************************************************************************
Public Sub GuardarDatoSistema(RutArch As String, Optional EsPlantilla As Boolean = False)
  Dim I As Integer, j As Integer, Progreso As Integer
  Dim TxtPlant As String
  
  If EsPlantilla Then
    TxtPlant = InputBox("Por favor, introduzca una descripcin para identificar la presente plantilla", "Guardando Plantilla", "Comentario...")
    EscribirINI RutArch, "BLOQUE DE DATOS GENERALES DEL " & SIGLA, "", "====================================="
    EscribirINI RutArch, SECCION_PLANTILLA, CLAVE_PLANTILLA, TxtPlant
  End If
  
  Progreso = 4500
  FrmProceso.Show , FrmMdi
  DoEvents
  'Cursor se visualiza en modo espera mediante un reloj de arena
  Screen.MousePointer = vbHourglass
  '--------
  'ALMACENAMIENTO DE INFORMACIN SOBRE LOS DATOS GENERALES DEL SISTEMA DE CONTROL DIFUSO, SECCIN [GENERAL]
  FrmProceso.LblCargando.Caption = "Almacenando datos generales..."
  EscribirINI RutArch, "BLOQUE DE DATOS GENERALES DEL " & SIGLA, "", "====================================="
  EscribirINI RutArch, SECCION_GENERAL, CLAVE_USUARIO, Trim$(SistActual.Usuario)
  EscribirINI RutArch, SECCION_GENERAL, CLAVE_TITULO, Trim$(SistActual.Titulo)
  EscribirINI RutArch, SECCION_GENERAL, CLAVE_OBSERVACIONES, Trim$(SistActual.Observaciones)
  EscribirINI RutArch, SECCION_GENERAL, CLAVE_NENTRADAS, NEntradas
  EscribirINI RutArch, SECCION_GENERAL, CLAVE_NSALIDAS, NSalidas
  EscribirINI RutArch, SECCION_GENERAL, CLAVE_NREGLAS, NReglas
  
  FrmProceso.ShapeRectangulo.Width = Progreso * 0.2
  
  'ALMACENAMIENTO DE INFORMACIN SOBRE LAS VARIABLES DE ENTRADA, SECCIN [E#]
  FrmProceso.LblCargando.Caption = "Almacenando conjunto de entradas..."
  EscribirINI RutArch, "BLOQUE DE VARIABLES DE ENTRADA", "", "===================================="
  For I = 0 To NEntradas - 1
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_ESTADO, QEstado(Entrada, I)
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_NOMBRE, QNombreEoS(E, I)
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_UNIDADES, Trim$(SistActual.Entrada(I).Unidades)
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_UNDSIGLA, Trim$(SistActual.Entrada(I).UndSigla)
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_OBSERVACIONES, Trim$(SistActual.Entrada(I).Observaciones)
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_UNIVDISC, VectorParametros(SistActual.Entrada(I).UnivDiscurso())
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_NOMSECUENCIA, Trim$(SistActual.Entrada(I).Secuencia.Nombre)
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_NVCRISPS, NVCrisps(E, I)
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_VCRIPS, VectorParametros(SistActual.Entrada(I).VCrisp())
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_DIFUSOR, QDifusor(I)
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_PBASICOS, VectorParametros(SistActual.Entrada(I).Difusor.PBasicos(), SistActual.Entrada(I).Difusor.Tipo)
    If SistActual.Entrada(I).Difusor.Tipo = DifTrapecioExtendido Then
      EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_DIFUSOR, "TrapecioExtendido"
      EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_NPEXTENDIDOS, NPExtendidos(E, I, Difusor, -1)
      EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_PEXTENDIDOS, VectorParametros(SistActual.Entrada(I).Difusor.PExtendidos(), SistActual.Entrada(I).Difusor.Tipo)
    End If
    EscribirINI RutArch, SECCION_ENTRADA & I, CLAVE_NCONJDIF, NConjDif(E, I)
    For j = 0 To NConjDif(E, I) - 1
      EscribirINI RutArch, SECCION_ENTRADA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_ETIQUETA, QEtiqueta(E, I, j)
      EscribirINI RutArch, SECCION_ENTRADA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_TIPO, QConjDif(E, I, j)
      EscribirINI RutArch, SECCION_ENTRADA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_PBASICOS, VectorParametros(SistActual.Entrada(I).ConjDif(j).PBasicos(), SistActual.Entrada(I).ConjDif(j).Tipo)
      If SistActual.Entrada(I).ConjDif(j).Tipo = TrapecioExtendido Then
        EscribirINI RutArch, SECCION_ENTRADA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_TIPO, "TrapecioExtendido"
        EscribirINI RutArch, SECCION_ENTRADA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_NPEXTENDIDOS, NPExtendidos(E, I, ConjDif, j)
        EscribirINI RutArch, SECCION_ENTRADA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_PEXTENDIDOS, VectorParametros(SistActual.Entrada(I).ConjDif(j).PExtendidos(), SistActual.Entrada(I).ConjDif(j).Tipo)
      End If
    Next j
  Next I
  
  FrmProceso.ShapeRectangulo.Width = Progreso * 0.5
  
  'ALMACENAMIENTO DE INFORMACIN SOBRE LAS VARIABLES DE SALIDA, SECCIN [S#]
  FrmProceso.LblCargando.Caption = "Almacenando conjunto de salidas..."
  EscribirINI RutArch, "BLOQUE DE VARIABLES DE SALIDA", "", "===================================="
  For I = 0 To NSalidas - 1
    EscribirINI RutArch, SECCION_SALIDA & I, CLAVE_ESTADO, QEstado(Salida, I)
    EscribirINI RutArch, SECCION_SALIDA & I, CLAVE_NOMBRE, QNombreEoS(S, I)
    EscribirINI RutArch, SECCION_SALIDA & I, CLAVE_UNIDADES, Trim$(SistActual.Salida(I).Unidades)
    EscribirINI RutArch, SECCION_SALIDA & I, CLAVE_UNDSIGLA, Trim$(SistActual.Salida(I).UndSigla)
    EscribirINI RutArch, SECCION_SALIDA & I, CLAVE_OBSERVACIONES, Trim$(SistActual.Salida(I).Observaciones)
    EscribirINI RutArch, SECCION_SALIDA & I, CLAVE_UNIVDISC, VectorParametros(SistActual.Salida(I).UnivDiscurso())
    EscribirINI RutArch, SECCION_SALIDA & I, CLAVE_CONCRESOR, QDefuzzificador(SistActual.Salida(I).Defuzzificador)
    EscribirINI RutArch, SECCION_SALIDA & I, CLAVE_NCONJDIF, NConjDif(S, I)
    For j = 0 To NConjDif(S, I) - 1
      EscribirINI RutArch, SECCION_SALIDA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_ETIQUETA, QEtiqueta(S, I, j)
      EscribirINI RutArch, SECCION_SALIDA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_TIPO, QConjDif(S, I, j)
      EscribirINI RutArch, SECCION_SALIDA & I, ABREVIAT_CONJDIF & j & GUION & CLAVE_PBASICOS, VectorParametros(SistActual.Salida(I).ConjDif(j).PBasicos(), SistActual.Salida(I).ConjDif(j).Tipo)
      If SistActual.Salida(I).ConjDif(j).Tipo = TrapecioExtendido Then
        EscribirINI RutArch, SECCION_SALIDA & I, "CD" & j & GUION & CLAVE_TIPO, "TrapecioExtendido"
        EscribirINI RutArch, SECCION_SALIDA & I, "CD" & j & GUION & CLAVE_NPEXTENDIDOS, NPExtendidos(S, I, ConjDif, j)
        EscribirINI RutArch, SECCION_SALIDA & I, "CD" & j & GUION & CLAVE_PEXTENDIDOS, VectorParametros(SistActual.Salida(I).ConjDif(j).PExtendidos(), SistActual.Salida(I).ConjDif(j).Tipo)
      End If
    Next j
  Next I
  FrmProceso.ShapeRectangulo.Width = Progreso * 0.8
  
  'ALMACENAMIENTO DE INFORMACIN SOBRE LA B.CONOCIMIENTO, SECCIN [R#]
  FrmProceso.LblCargando.Caption = "Almacenando conjunto de reglas..."
  EscribirINI RutArch, "BLOQUE DE REGLAS - B.CONOCIMIENTO", "", "=================================="
  For I = 0 To NReglas - 1
    EscribirINI RutArch, SECCION_REGLA & I, CLAVE_ESTADO, QEstado(Regla, I)
    EscribirINI RutArch, SECCION_REGLA & I, CLAVE_OPERADOR, QOperador(SistActual.Regla(I).Operador)
    EscribirINI RutArch, SECCION_REGLA & I, CLAVE_OBSERVACIONES, Trim$(SistActual.Regla(I).Observaciones)
    EscribirINI RutArch, SECCION_REGLA & I, CLAVE_NANT, NAntecedentes(I)
    EscribirINI RutArch, SECCION_REGLA & I, CLAVE_NCONS, NConsecuentes(I)
    For j = 0 To NAntecedentes(I) - 1
      EscribirINI RutArch, SECCION_REGLA & I, ABREVIAT_ANTECED & j & GUION & CLAVE_ACTIVO, AntecedenteActivo(I, j)
      EscribirINI RutArch, SECCION_REGLA & I, ABREVIAT_ANTECED & j & GUION & CLAVE_ENTRADA, UCase$(Trim$(SistActual.Regla(I).Antecedente(j).NombreEoS))
      EscribirINI RutArch, SECCION_REGLA & I, ABREVIAT_ANTECED & j & GUION & CLAVE_ETIQUETA, UCase$(Trim$(SistActual.Regla(I).Antecedente(j).EtiquetaConjDif))
      EscribirINI RutArch, SECCION_REGLA & I, ABREVIAT_ANTECED & j & GUION & CLAVE_OPNOT, OpNotActivado(SistActual.Regla(I).Antecedente(j).OpNot)
    Next j
    For j = 0 To NConsecuentes(I) - 1
      EscribirINI RutArch, SECCION_REGLA & I, ABREVIAT_CONSEC & j & GUION & CLAVE_ACTIVO, ConsecuenteActivo(I, j)
      EscribirINI RutArch, SECCION_REGLA & I, ABREVIAT_CONSEC & j & GUION & CLAVE_SALIDA, UCase$(Trim$(SistActual.Regla(I).Consecuente(j).NombreEoS))
      EscribirINI RutArch, SECCION_REGLA & I, ABREVIAT_CONSEC & j & GUION & CLAVE_ETIQUETA, UCase$(Trim$(SistActual.Regla(I).Consecuente(j).EtiquetaConjDif))
      EscribirINI RutArch, SECCION_REGLA & I, ABREVIAT_CONSEC & j & GUION & CLAVE_OPNOT, OpNotActivado(SistActual.Regla(I).Consecuente(j).OpNot)
    Next j
  Next I
  
  'ALMACENAMIENTO DE INFORMACIN SOBRE EL MOTOR DE INFERENCIA [MOTOR DE INFERENCIA]
  FrmProceso.LblCargando.Caption = "Almacenando motor de inferencia..."
  EscribirINI RutArch, "BLOQUE DEL MOTOR DE INFERENCIA", "", "=================================="
  
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_OPIMPLICACION, QImplicacion(SistActual.Inferencia.OpImplicacion)
  
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_OPAGREGACION, QNorma(SistActual.Inferencia.OpAgregacion.TipoNorma)
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_P_OPAG, CStr(SistActual.Inferencia.OpAgregacion.p)
  
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_OPANDTNORMA, QNorma(SistActual.Inferencia.OpAnd.TipoNorma)
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_P_OPAND, CStr(SistActual.Inferencia.OpAnd.p)
  
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_OPORSNORMA, QNorma(SistActual.Inferencia.OpOr.TipoNorma)
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_P_OPOR, CStr(SistActual.Inferencia.OpOr.p)
  
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_OPDIFUMINACION, QNorma(SistActual.Inferencia.OpDifuminacion.TipoNorma)
  EscribirINI RutArch, SECCION_MOTOR, CLAVE_P_OPDF, CStr(SistActual.Inferencia.OpDifuminacion.p)
  
  FrmProceso.ShapeRectangulo.Width = Progreso * 1
  '--------
  Unload FrmProceso
  Screen.MousePointer = vbDefault
  
End Sub

'**************************************************************************************************
'   FUNCIN: VectorParametros()
'**************************************************************************************************
Private Function VectorParametros(Valores() As Double, _
                                  Optional TipoCDif As ETCONJDIF = TrapecioExtendido) As String
  On Error GoTo SinValores
  Dim MSubValores As Integer, I As Integer
  Dim Temp_Vector As String
  
  Temp_Vector = "["
  
  Select Case TipoCDif
    
    Case L:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
    Case Gamma:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
      
    Case DifTrapecio:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
    Case Trapecio:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
      
    Case DifTriangulo:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
    Case Triangulo:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
      
    Case DifIntervalo:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
    Case Intervalo:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
      
    Case DifSingleton:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
    Case Singleton:
      Temp_Vector = Temp_Vector & Round(Valores(0), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(1), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(2), NUMDEC) & "; "
      Temp_Vector = Temp_Vector & Round(Valores(3), NUMDEC) & "]"
    
    Case DifTrapecioExtendido:
      MSubValores = UBound(Valores(), 1)
      For I = 0 To MSubValores
        If I = MSubValores Then
          Temp_Vector = Temp_Vector & Round(Valores(I), NUMDEC) & "]"
        Else
          Temp_Vector = Temp_Vector & Round(Valores(I), NUMDEC) & "; "
        End If
      Next I
    Case TrapecioExtendido:
      MSubValores = UBound(Valores(), 1)
      For I = 0 To MSubValores
        If I = MSubValores Then
          Temp_Vector = Temp_Vector & Round(Valores(I), NUMDEC) & "]"
        Else
          Temp_Vector = Temp_Vector & Round(Valores(I), NUMDEC) & "; "
        End If
      Next I
      
    Case Else
      
      Temp_Vector = VectorCadena(Valores())
  End Select
    
SinValores:
    If Err.Number = 9 Then
      Err.Clear
      Temp_Vector = ""
    End If
    
  VectorParametros = Temp_Vector

End Function


'**************************************************************************************************
'   FUNCIN: VectorCadena()
'**************************************************************************************************
Private Function VectorCadena(Valores() As Double) As String
  On Error GoTo SinValores
  Dim MSubValores As Integer, I As Integer
  Dim Temp_Vector As String
  
  Temp_Vector = "["
  MSubValores = UBound(Valores(), 1)
  For I = 0 To MSubValores
    If I = MSubValores Then
      Temp_Vector = Temp_Vector & Round(Valores(I), NUMDEC) & "]"
    Else
      Temp_Vector = Temp_Vector & Round(Valores(I), NUMDEC) & "; "
    End If
  Next I
  
SinValores:
  If Err.Number = 9 Then
    Err.Clear
    Temp_Vector = ""
  End If
  
  VectorCadena = Temp_Vector

End Function


'**************************************************************************************************
'   PROCEDIMIENTO: LeerVector()
'**************************************************************************************************
Public Sub LeerVector(Cadena As String, TipoBusqueda As ETBUSQUEDANUMEROS, _
                      NumBusquedas As Double, Limitadores() As Double, _
                      Valores() As Double, Fallo As Boolean)
    
    'Declaracin de constantes y variables
    Const A_CORCHETE = "["
    Const C_CORCHETE = "]"
    Const PTOYCOMA = ";"
    
    Dim ValorEnCadena As String
    Dim I As Integer, DelimitadorIzdo As Integer, DelimitadorDcho As Integer
    
    'Inicializamos considerando que inicialmente no hay errores en los datos
    Fallo = False
    ReDim Valores(0)
    'Si la cadena est vaca terminamos de forma errnea
    If Len(Cadena) = 0 Then
        Fallo = True
        Exit Sub
    End If
    'Se delimita el primer valor comprendido entre el "[" y la ";"
    'Buscar el corchete de inicio
    DelimitadorIzdo = InStr(Cadena, A_CORCHETE) + 1
    'Ser requisito imprescindible que existe este corchete indicador de comienzo de valores
    'pues en el caso de no existir en la cadena se producir fallo
    If DelimitadorIzdo = 1 Then
        Fallo = True
        Exit Sub
    End If
    'Busca la primera PTOYCOMA delimitadora
    DelimitadorDcho = InStr(Cadena, PTOYCOMA) - 1
    'Si no encontramos la primera PTOYCOMA se producir fallo pues como mnimo se necesitar siempre
    'dos valores (ej: Universo Discurso,...) luego ha de existir una PTOYCOMA como
    'mnimo
    If DelimitadorDcho = -1 Then
     If NumBusquedas > 1 Then
        Fallo = True
        Exit Sub
     ElseIf NumBusquedas = 1 Then
       DelimitadorDcho = InStr(Cadena, C_CORCHETE)
       ValorEnCadena = MId$(Cadena, DelimitadorIzdo, DelimitadorDcho - DelimitadorIzdo)
       If IsNumeric(ValorEnCadena) Then
            If Not (CDbl(ValorEnCadena) >= Limitadores(0) - 2 * EPSILON And CDbl(ValorEnCadena) <= Limitadores(1)) + 2 * EPSILON Then
              Fallo = True
              Exit Sub
            End If
            Valores(0) = CDbl(ValorEnCadena)
            Exit Sub
       End If
     Else
       DelimitadorDcho = InStr(Cadena, C_CORCHETE) - 1
       ValorEnCadena = MId$(Cadena, DelimitadorIzdo, DelimitadorDcho - DelimitadorIzdo)
       If IsNumeric(ValorEnCadena) Then
            If Not (CDbl(ValorEnCadena) >= Limitadores(0) - 2 * EPSILON And CDbl(ValorEnCadena) <= Limitadores(1)) + 2 * EPSILON Then
              Fallo = True
              Exit Sub
            End If
            Valores(0) = CDbl(ValorEnCadena)
            Exit Sub
       End If
     End If
    End If
    'Establece el nmero de busquedas, es decir, el nmero de valores que se desean obtener
    'del array de parmetros ej: [valor1,valor2,valor3,...,valorn]
    For I = 1 To NumBusquedas
        DelimitadorDcho = DelimitadorDcho + 1
        'Se toma la cadena que contiene el posible valor entre los delimitadores
        ValorEnCadena = MId$(Cadena, DelimitadorIzdo, DelimitadorDcho - DelimitadorIzdo)
        'Comprueba que se trata de un nmero
        If IsNumeric(ValorEnCadena) Then
            Select Case TipoBusqueda
              Case Desordenada
                    If Not (CDbl(ValorEnCadena) >= Limitadores(0) - 2 * EPSILON And CDbl(ValorEnCadena) <= Limitadores(1)) + 2 * EPSILON Then
                      Fallo = True
                      Exit For
                    End If
                    If I > 1 Then ReDim Preserve Valores(UBound(Valores, 1) + 1)
                    Valores(I - 1) = CDbl(ValorEnCadena)
              Case DesordenadaSinLimites
                    If I > 1 Then ReDim Preserve Valores(UBound(Valores, 1) + 1)
                    Valores(I - 1) = CDbl(ValorEnCadena)
              Case Ordenada
                    If I = 1 And (CDbl(ValorEnCadena) >= Limitadores(0) - 2 * EPSILON And CDbl(ValorEnCadena) <= Limitadores(1)) + 2 * EPSILON Then
                        Valores(I - 1) = CDbl(ValorEnCadena)
                    ElseIf I > 1 And (Valores(I - 2) > CDbl(ValorEnCadena)) And _
                           (CDbl(ValorEnCadena) >= Limitadores(0) - 2 * EPSILON And CDbl(ValorEnCadena) <= Limitadores(1)) + 2 * EPSILON Then
                        Fallo = True
                        Exit For
                    Else
                        ReDim Preserve Valores(UBound(Valores, 1) + 1)
                        Valores(I - 1) = CDbl(ValorEnCadena)
                    End If
              Case OrdenadaSinLimites
                    If I = 1 Then
                      Valores(I - 1) = CDbl(ValorEnCadena)
                    ElseIf I > 1 And Not (Valores(I - 2) <= CDbl(ValorEnCadena)) Then
                      Fallo = True
                      Exit For
                    Else
                      ReDim Preserve Valores(UBound(Valores, 1) + 1)
                      Valores(I - 1) = CDbl(ValorEnCadena)
                    End If
                    
              Case Extendida
                    'SI EL INDICE i ES PAR Y...
                    If ((I - 1) Mod 2 = 0) And ((CDbl(ValorEnCadena) > Limitadores(A) And CDbl(ValorEnCadena) < Limitadores(B)) Or _
                                                (CDbl(ValorEnCadena) > Limitadores(C) And CDbl(ValorEnCadena) < Limitadores(D))) Then
                    
                        If I - 1 = 0 Then
                          Valores(I - 1) = CDbl(ValorEnCadena)
                        Else
                          If Valores(I - 3) <= CDbl(ValorEnCadena) Then
                            ReDim Preserve Valores(UBound(Valores, 1) + 1)
                            Valores(I - 1) = CDbl(ValorEnCadena)
                          End If
                        End If
                    'SI NO ES PAR Y...
                    ElseIf Not ((I - 1) Mod 2 = 0) And ((CDbl(ValorEnCadena) <= 1#) And (CDbl(ValorEnCadena) >= 0#)) Then
                        ReDim Preserve Valores(UBound(Valores, 1) + 1)
                        Valores(I - 1) = CDbl(ValorEnCadena)
                    Else
                      Fallo = True
                      Exit For
                    End If
              End Select
        Else
            Fallo = True
            Exit For
        End If
        'En el momento que se encuentra aquel numero de valores segn NumBusquedas y estos
        'hayan sido todos entendidos como nmeros correctos y cumplidores de a<b<c<d se dar por
        'finalizado el objetivo de este procedimiento devolviendo Valores() sin error.
        'Puede ser que la cadena contenga ms valores de los que se solicitan, este posible
        'exceso no ocasionar error ya que el procedimiento ir tomando los valores que determine
        'la variable NumBusquedas mientras que estos no sean erroneos
        If I = NumBusquedas Then Exit For
        'Si todavia quedan valores por recuperar se desplazaran los delimitadores a las nuevas posiciones
        'que hagan apuntar al prximo valor a recuperar
        DelimitadorIzdo = DelimitadorDcho + 1
        DelimitadorDcho = InStr(DelimitadorIzdo, Cadena, PTOYCOMA) - 1
        'Si la funcin InStr devuelve 0 indicar que no ha encontrado el caracter especificado, en este
        'caso la PTOYCOMA lo cual querr decir o bien existe un nico valor ms en la cadena o se ha llegado
        'ya al final siendo para este ltimo caso la bsqueda del C_CORCHETE que en caso de no encontrarse
        'provocara la determinacin de error.
        If DelimitadorDcho = -1 Then
            DelimitadorDcho = InStr(DelimitadorIzdo, Cadena, C_CORCHETE) - 1
            If DelimitadorDcho = -1 Then
                Fallo = True
                Exit For
            End If
        End If
    Next I
       
End Sub

