Attribute VB_Name = "Inputs"
'-------------------------------------------------------------------------------------------------------
'                                  ## MDULO DE CDIGO: INPUTS.BAS ##
'
' OBJETIVO:
'-------------------------------------------------------------------------------------------------------

Option Explicit

Public NuevoCDifusoEnEntrada As Boolean
Public SuprimidaEntrada As TEVARIABLE
Public HayEntradaEliminada As Boolean


'**************************************************************************************************
'   PROPIEDAD: NEntradas()
'**************************************************************************************************
Public Property Get NEntradas() As Integer
  On Error GoTo Fallo:
  Dim i As Integer
  
  i = UBound(SistActual.Entrada(), 1)
  NEntradas = i + 1
  Exit Property
Fallo:
  If Err.Number = 9 Then
    NEntradas = 0
    Err.Clear
  End If
End Property

'**************************************************************************************************
'   PROPIEDAD: NEntradasActivas()
'**************************************************************************************************
Public Property Get NEntradasActivas() As Integer
  Dim i As Integer, j As Integer
  j = 0
  
  For i = 0 To NEntradas - 1
    If SistActual.Entrada(i).Activa = Si Then
      j = j + 1
    End If
  Next i
  NEntradasActivas = j
  
End Property

'**************************************************************************************************
'   PROPIEDAD: NEntradasPasivas()
'**************************************************************************************************
Public Property Get NEntradasPasivas() As Integer
  NEntradasPasivas = NEntradas - NEntradasActivas
End Property

'**************************************************************************************************
'   PROPIEDAD: QDifusor()
'**************************************************************************************************
Public Property Get QDifusor(IdEntrada As Integer) As String
  
  Select Case SistActual.Entrada(IdEntrada).Difusor.Tipo
    Case DifSingleton:
      QDifusor = "Singleton"
    Case DifIntervalo:
      QDifusor = "Intervalo"
    Case DifTriangulo:
      QDifusor = "Triangulo"
    Case DifTrapecio:
      QDifusor = "Trapecio"
    Case DifTrapecioExtendido:
      QDifusor = "Trapecio Extendido"
  End Select

End Property

'**************************************************************************************************
'   PROCEDIMIENTO: EliminarEntradaMatriz()
'**************************************************************************************************
Public Sub EliminarEntradaMatriz(Matriz() As TEVARIABLE, Posicion As Integer, EntradaSuprimida As TEVARIABLE)
  On Error Resume Next
  Dim i As Integer, NElementosMatriz As Integer
  'Se calcula el nmero de elementos de la matriz
  i = UBound(Matriz(), 1)
  If Err.Number = 9 Then
    NElementosMatriz = 0
    Err.Clear
  Else
    NElementosMatriz = i + 1
  End If
  'Antes de proceder a su eliminacin este se almacena como informacin a reconstruir en caso de querer
  'el usuario deshacer la eliminacin de entrada
  EntradaSuprimida = Matriz(Posicion)
  'Dado que la matriz comienza en el elemento Matriz(0) el ndice ira de 0 -> (NElementosMatriz -1)
  'SI LA MATRIZ CONTIENE UN SOLO ELEMENTO
  If NElementosMatriz = 1 Then
    'Se liberar memoria ocupada por la matriz dinmica Matriz()
    Erase Matriz()
  'SI LA MATRIZ CONTIENE MS DE UN ELEMENTO Y EL SELECCIONADO PARA ELIMINAR ES EL LTIMO
  ElseIf (Posicion = (NElementosMatriz - 1)) And NElementosMatriz > 1 Then
    'Redimensionamos la matriz a un elemento menos conservando los existentes menos el ltimo
    ReDim Preserve Matriz(NElementosMatriz - 2)
  Else
    'Trasladamos los datos de la posicin i a i-1
    For i = Posicion + 1 To (NElementosMatriz - 1)
      Matriz(i - 1) = Matriz(i)
    Next i
    'Redimensionamos la matriz a un elemento menos conservando los existentes menos el ltimo
    ReDim Preserve Matriz(NElementosMatriz - 2)
  End If
End Sub

'**************************************************************************************************
'   PROCEDIMIENTO: AadirEntradaMatriz()
'**************************************************************************************************
Public Sub AadirEntradaMatriz(Matriz() As TEVARIABLE, EntradaInsertar As TEVARIABLE, _
                               Optional PosicionFinal As Boolean = True, Optional Posicion As Integer)
  On Error Resume Next
  Dim i As Integer, MIndInicial As Integer, NSaltos As Integer, NElementosMatriz As Integer
  
  'Se calcula el nmero de elementos de la matriz
  i = UBound(Matriz(), 1)
  If Err.Number = 9 Then
    NElementosMatriz = 0
    Err.Clear
  Else
    NElementosMatriz = i + 1
  End If
  
  MIndInicial = NElementosMatriz - 1
  If PosicionFinal Then
    ReDim Preserve Matriz(MIndInicial + 1)
    Matriz(MIndInicial + 1) = EntradaInsertar
    Exit Sub
  End If
  
  If NElementosMatriz = 0 Then
    ReDim Matriz(0)
    Matriz(0) = EntradaInsertar
  ElseIf Posicion > MIndInicial Then
    ReDim Preserve Matriz(MIndInicial + 1)
    Matriz(Posicion) = EntradaInsertar
    Exit Sub
  ElseIf Posicion < 0 Then
    Posicion = 0
    GoTo Seguir
  Else
Seguir:
    ReDim Preserve Matriz(MIndInicial + 1)
    NSaltos = (MIndInicial + 1) - Posicion
    For i = 1 To NSaltos
      Matriz((MIndInicial + 2) - i) = Matriz((MIndInicial + 1) - i)
    Next i
    Matriz(Posicion) = EntradaInsertar
  End If
  
End Sub








