Attribute VB_Name = "Kernel"
'-------------------------------------------------------------------------------------------------------
'                                ## MDULO DE CDIGO: KERNEL.BAS ##
'
' OBJETIVO: Contener el cdigo necesario para realizar las funciones principales de la aplicacin.
'
'           - Contiene la definicin de las estructuras, enumeraciones, variables y constantes ms
'             importantes sobre las que se sustenta toda la informacin del sistema.
'
'-------------------------------------------------------------------------------------------------------
Option Explicit

'---------------------------------
' - DECLARACIN DE ENUMERACIONES -
'---------------------------------

'%%%%% ENUMERACIN INDICADORA DEL ESTADO ACTIVO SOBRE UNA VARIABLE %%%%%
Public Enum ETACTIVADO
    Si = 0
    No = 1
End Enum

'%%%%% ESTADOS POSIBLES SOBRE UNA REGLA %%%%%
Public Enum ETESTADO
  Activo = 0
  SemiActivo = 1
  Pasivo = 2
End Enum


'%%%%% TIPOS DE OPERADORES %%%%%
Public Enum ETOPERADOR
  AAnd = 0
  OOr = 1
End Enum

'%%%%% ENUMERACIN IDENTIFICADORA DEL TIPO DE PARMETRO %%%%%
Public Enum ETPBASICOS
    A = 0
    B = 1
    C = 2
    D = 3
    EX = 4
End Enum

'%%%%% TIPOS DE DIFUSORES %%%%%
Public Enum ETDIFUSORES
    DifSingleton = 20
    DifIntervalo = 21
    DifTriangulo = 22
    DifTrapecio = 23
    DifTrapecioExtendido = 24
End Enum

'%%%%% TIPOS DE DEFUZZIFICADORES o CONCRESORES %%%%%
Public Enum ETDEFUZZIFICADORES
    'ENUMERACIN DECLARADA CON VALORES QUE DETERMINAN EL TIPO DE DEFUMINACIN
       ' >= 100 CONLLEVA METODOS DE DEFUZZIFICACION Q NO OPERAN SOBRE EL CONJUNTO RESULTANTE TRAS EL
       '              TRAS EL PROCESO DE AGREGACIN SINO QUE DIRECTAMENTE CALCULAN SU CARACERSTICAS (W, G, H, S).
       
       '< 100 SON AQUELLOS MTODOS DE DEFUZZIFICACIN QUE TRABAJAN DIRECTAMENTE CON EL CONJ. DIFUSO DE AGREGACIN.
    
    
    'BASADOS EN EL CENTRO DE GRAVEDAD (CoG)
    CoG_Centro_Gravedad = 0
    CoG_Valores_Importantes = 1
    
    CoG_Ponderado_Area = 100
    CoG_Ponderado_Altura = 101
    CoG_Mayor_Area = 102
    CoG_Mayor_Altura = 103
    
    'BASADOS EN EL PTO MXIMO CRITERIO (PMC)
    PMC_Primer_Maximo = 10
    PMC_Media_Maximos = 11
    PMC_Ultimo_Maximo = 12
    
    PMC_Media = 110
    PMC_Media_Min_Max = 111
    PMC_Ponderado_Area = 112
    PMC_Ponderado_Altura = 113
    PMC_Mayor_Area = 114
    PMC_Mayor_Altura = 115
    
    'BASADOS EN EL CENTRO DE AREA (CoA)
    CoA_Centro_Area = 20
    CoA_Valores_Importantes = 21
    
End Enum

'%%%%% TIPOS DE CONJUNTOS DIFUSOS %%%%%
Public Enum ETCONJDIF
    Singleton = 10
    Intervalo = 11
    L = 12
    Triangulo = 13
    Trapecio = 14
    Gamma = 15
    TrapecioExtendido = 16
End Enum

'%%%%% TIPOS DE IMPLICACIONES %%%%%
Public Enum ET_IMPLICACIONES
  'S-IMPLICACIONES o IMPLICACIONES FUERTES
  Implicacion_S_Diene = 0
  Implicacion_S_DuboisPrade = 1
  Implicacion_S_Mizumoto = 2
  
  'R-IMPLICACIONES o IMPLICACIONES RESIDUALES
  Implicacion_R_Goguen = 10
  Implicacion_R_Godel = 11
  Implicacion_R_Gaines = 12
  
  'RS-IMPLICACIONES
  Implicacion_RS_Lukasiewicz = 20
  
  'QM-IMPLICACIONES o IMPLICACIONES DE LA MECNICA CUNTICA
  Implicacion_QM_EarlyZadeh = 30
  
  'T-IMPLICACIONES o IMPLICACIONES CON T-NORMAS
  Implicacion_T_Minimo = 40
  Implicacion_T_ProductoAlgebraico = 41
  Implicacion_T_ProductoAcotado = 42
  
End Enum

'%%%%% TIPOS DE NORMAS %%%%%
Public Enum ET_TNORMAS_SNORMAS
  'Enumaracin de T-NORMAS
  TNorma_Minino = 0
  TNorma_Producto_Algebraico = 1
  TNorma_Producto_Drastico = 2
  TNorma_Producto_Acotado = 3
  TNorma_Producto_Hamacher = 4
  TNorma_Familia_Yager = 5
  TNorma_Familia_DuboisPrade = 6
  TNorma_Familia_Frank = 7
  TNorma_Producto_Einstein = 8
  'Enumaracin de S-NORMAS o T-CONORMAS
  SNorma_Maximo = 10
  SNorma_Suma_Producto = 11
  SNorma_Suma_Drastica = 12
  SNorma_Suma_Acotada = 13
  SNorma_Familia_Sugeno = 14
  SNorma_Familia_Yager = 15
  SNorma_Familia_DuboisPrade = 16
  SNorma_Familia_Frank = 17
  
End Enum

Public Enum ET_QPASOCARGAR
  Ninguno = 0
  Paso_Difuminacion = 1
  Paso_ActivReglas = 2
  Paso_Implicacion = 3
  Paso_Agregacion = 4
  Paso_Concrecion = 5
End Enum

Public Enum ET_TIPOVISUALIZACION
  Ninguna = 0
  Una = 1
  Todas = 2
  TodasSinResultado = 3
End Enum

Public Enum ET_SECUENCIAS
  S_Propia = 0
  S_Lineal = 1
  S_Aleatoria = 2
  
End Enum

'--------------------------------------------------------
'      ---- DECLARACIN DE TIPOS (ESTRUCTURAS) ----
'
' Aclaraciones:
'
'   - Es muy importante declarar antes un tipo que
'     otro, si el anterior utilizase el posterior no
'     funcionar.
'
'   - El tipo Double = Decimal de rango posible
'     de +/-5E-324 a 1.8E308).
'
'   - 'Matrices DINMICAS -> NombreMatriz() as Tipo '
'      Debern ser redimensionadas a la hora
'        de utilizar dicho campo de la estructura !!.
'--------------------------------------------------------

Public Type T_SECUENCIA
  Nombre As String
  Tipo As ET_SECUENCIAS
End Type

Public Type T_VISUALIZACION
  ClaseVisualizacion As ET_TIPOVISUALIZACION
  IdEtiqueta As Integer
End Type

'%%%%%%% ESTRUCTURA GESTION ENTRADAS/SALIDAS %%%%%%%
Public Type TGESTIONEOS
  EsEntrada As Boolean
  EliminarEntrada As Boolean
  NuevaEoS As Boolean
End Type

'%%%%%%% ESTRUCTURA ARCHIVO %%%%%%%
Public Type TARCHIVO
  Nombre As String
  Nuevo As Boolean
  Cargado As Boolean
  Modificado As Boolean
End Type

'%%%%%%% ESTRUCTURA DIFUSOR %%%%%%%
Public Type TDIFUSORES
    Tipo As ETDIFUSORES
    PBasicos(0 To 3) As Double
    PExtendidos() As Double
End Type

'%%%%%%% ESTRUCTURA CARACTERISTICAS_CONJDIF %%%%%%%
Public Type TCARACTERISTICAS_CONJDIF
   G As Double  'MoM (PMC)
   S As Double  'REA
   w As Double  'CENTRO DE GRAVEDAD (CoG)
   H As Double  'ALTURA
End Type

'%%%%%%% ESTRUCTURA CONJUNTO DIFUSO %%%%%%%
Public Type TCONJDIFUSO
    Etiqueta As String * 50
    Tipo As ETCONJDIF
    Caracteristicas As TCARACTERISTICAS_CONJDIF
    Poss As Double
    GACTIVACION_MAX As Double
    PBasicos(0 To 3) As Double
    PExtendidos() As Double
    CoordXGActiv() As Double
    CoordYGActiv() As Double
End Type

'%%%%%%% ESTRUCTURA TRMINO DE REGLA %%%%%%%
Public Type TTERMINO
  Activa As ETACTIVADO
  OpNot As Boolean
  NombreEoS As String * 40
  EtiquetaConjDif As String * 50
End Type

'%%%%%%% ESTRUCTURA REGLA %%%%%%%
Public Type TBCONOCIMIENTO
    Estado As ETESTADO
    Antecedente() As TTERMINO
    GACTIVACION As Double
    Operador As ETOPERADOR
    Consecuente() As TTERMINO
    Observaciones As String * 200
End Type


'%%%%%%% ESTRUCTURA VARIABLE DE ENTRADA %%%%%%%
Public Type TEVARIABLE
    Nombre As String * 40
    Unidades As String * 20
    UndSigla As String * 10
    Observaciones As String * 200
    Secuencia As T_SECUENCIA
    Activa As ETACTIVADO
    'Con dos posiciones 0 - Mnimo, 1 - Mximo, [Min..Max]
    UnivDiscurso(0 To 1) As Double
    Difusor As TDIFUSORES
    ConjDif() As TCONJDIFUSO
    VCrisp() As Double
End Type

'%%%%%%% ESTRUCTURA VARIABLE DE SALIDA %%%%%%%
Public Type TSVARIABLE
    Nombre As String * 40
    Unidades As String * 20
    UndSigla As String * 10
    Observaciones As String * 200
    Activa As ETACTIVADO
    UnivDiscurso(0 To 1) As Double
    Defuzzificador As ETDEFUZZIFICADORES
    ConjDif() As TCONJDIFUSO
    CoordXAgreg() As Double
    CoordYAgreg() As Double
    VCrisp() As Double
End Type

'%%%%%%% ESTRUCTURA NORMA %%%%%%%
Public Type TSNorma
  TipoNorma As ET_TNORMAS_SNORMAS
  p As Double
End Type

'%%%%%%% ESTRUCTURA INFERENCIA %%%%%%%
Public Type TINFERENCIA
   OpImplicacion As ET_IMPLICACIONES
   OpAgregacion As TSNorma
   OpAnd As TSNorma
   OpOr As TSNorma
   OpDifuminacion As TSNorma
End Type

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'%%%%%%% ESTRUCTURA GENERAL DEL SITEMA %%%%%%%
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Public Type TSISTEMA
    Usuario As String * 50
    Titulo As String * 80
    Observaciones As String * 200
    Entrada() As TEVARIABLE
    Salida() As TSVARIABLE
    Regla() As TBCONOCIMIENTO
    Inferencia As TINFERENCIA
End Type


'---------------------------------
' --- DECLARACIN DE VARIABLES ---
'---------------------------------

Public ArchivoActual As TARCHIVO

Public GestionEoS As TGESTIONEOS

Public SistActual As TSISTEMA

Public VentanaEntrada() As FrmEntrada
Public VentanaSalida() As FrmSalida

Public QPasoCargar As ET_QPASOCARGAR

Public IdNombre_E_Seleccionada_Paso As String
Public IdNombre_S_Seleccionada_Paso As String

Public TipoVisualizacion As T_VISUALIZACION

Public CargadaVentanaCalculoSecuencias As Boolean

Public VersionDemo As Boolean

'---------------------------------
' -- DECLARACIN DE CONSTANTES --
'---------------------------------
'MBITO GLOBAL

Public Const SIGLA = "SCD"
Public Const SIGLA_INGLES = "FKBC"

Public Const EXTENSION_ARCHIVO_INICIALIZACION = "INI"
Public Const EXTENSION_ARCHIVOS_COPIAS_SEGURIDAD = "BAK"
Public Const EXTENSION_ARCHIVOS_PLANTILLAS = "SCP"
Public Const EXTENSION_ARCHIVO_REGISTRO = "TXT"

Public Const NOMBRE_ARCHIVO_REGISTRO = SIGLA & "REG"

Public Const NOMBRE_DIRECTORIO_COPSEG = "COPSEG"
Public Const NOMBRE_DIRECTORIO_PLANTILLAS = "PLANTILLAS"

Public Const NOMBRE_APLICACION_ESPAOL = "Sistema de Control Difuso (" & SIGLA & ")"
Public Const NOMBRE_APLICACION_INGLES = "Fuzzy Knowledge Based Controller (" & SIGLA_INGLES & ")"
Public Const NOMBRE_DESCRIPCION = "Programa que permite desarrollar y evaluar Sistemas basados en Lgica Difusa."

Public Const NUMDEC = 4

Public Const TIEMPO_FINALIZACION_FRMFINALIZACION = 2

Public Const EPSILON = 0.001

Public Const NUM_ESTADOS = 24

Public Const NUM_MAX_ENTRADAS_VERSION_DEMO = 2
Public Const NUM_MAX_SALIDAS_VERSION_DEMO = 2
Public Const NUM_MAX_REGLAS_VERSION_DEMO = 10

  

'**************************************************************************************************
'   PROCEDIMIENTO: LiberardeMemoria()
'**************************************************************************************************
Public Sub LiberardeMemoria(Vble As TSISTEMA)
  
  Vble.Usuario = ""
  Vble.Titulo = ""
  Vble.Observaciones = ""
  Erase Vble.Entrada()
  Erase Vble.Regla()
  Erase Vble.Salida()
  
End Sub
 
