Attribute VB_Name = "FuzzyOpSets"
'-------------------------------------------------------------------------------------------------------
'                                   ## MDULO DE CDIGO: FUZZYOPSETS.BAS ##
'
' OBJETIVO: Implementacin de algoritmos que realizen por aplicacin de t-normas o t-conormas
'           las operaciones de interseccin o unin respectivamente sobre dos conjuntos difusos.
'-------------------------------------------------------------------------------------------------------
    

'**************************************************************************************************
'   PROCEDIMIENTO: INTERSECCION_TNORMA_MINIMO()
'
'       OBJETIVO:
'
'**************************************************************************************************
Public Sub INTERSECCION_TNORMA_MINIMO(CDAX() As Double, CDAY() As Double, CDBX() As Double, CDBY() As Double, _
                                      CDINTX() As Double, CDINTY() As Double)

  Dim IdA As Integer, IdB As Integer, I As Integer
  Dim SegActual As ETSEGACTUAL
  Dim YSegActivo As Double
  Dim TempX As Double, TempY As Double
  Dim Intersecta As Boolean
  
  Erase CDINTX()
  Erase CDINTY()
  
  'HAY QUE COMPROBAR QUE LOS LIMITES PARA AMBOS CONJUNTOS SON LOS MISMOS Y SI NO FUERA AS LA SGTE
  'FUNCIN LOS IGUALAR PARA QUE LOS PUNTOS INICIALES CDAX(0) = CDBX(0) & CDAX(ULTIMO) = CDBX(ULTIMO).
  IgualarLimitesVectores CDAX(), CDAY(), CDBX(), CDBY()
  
  'EMPEZAMOS POR EL SEGUNDO PTO YA QUE EL PRIMERO ES IGUAL PARA AMBOS CONJ.DIFUSOS (0,0)
  IdA = 1
  IdB = 1
  
  'EL PRIMER PUNTO SIEMPRE ES VLIDO
  IntroducirValorMatriz CDINTX(), CDAX(0), CDINTY(), CDAY(0)
    
  'EVALUACIN DEL PRIMER PUNTO
  If (CDAX(IdA) <= CDBX(IdB)) Then
    'PRIMER SEGMENTO DEL CONJ. DIFUSO 1
    SegActual = SegA
  Else
    'PRIMER SEGMENTO DEL CONJ. DIFUSO 2
    SegActual = SegB
  End If
  
  'SIGUIENTES PUNTOS
 Do While ((IdA < UBound(CDAX(), 1) And IdB < UBound(CDBX(), 1)))
   
    If SegActual = SegA Then
        If (CDAX(IdA) <= CDBX(IdB)) Then
            'EL SGTE PUNTO ES DEL CONJ. DIFUSO 1
            YSegActivo = CoordYPtoCEnSegAB(CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                           CDAX(IdA), CDAY(IdA), Intersecta)
            If Not Intersecta Then
              IntroducirValorMatriz CDINTX(), CDAX(IdA), CDINTY(), CDAY(IdA)
              IdA = IdA + 1
            ElseIf CDAY(IdA) < YSegActivo Then
              IntroducirValorMatriz CDINTX(), CDAX(IdA), CDINTY(), CDAY(IdA)
              IdA = IdA + 1
            Else
              PtoIntSegQSeCruzanUnPto CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
              CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegB
              IdA = IdA + 1
            End If
        Else
            'EL SGTE PUNTO ES DEL CONJ. DIFUSO 2
            YSegActivo = CoordYPtoCEnSegAB(CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                           CDBX(IdB), CDBY(IdB), Intersecta)
            If Not Intersecta Then
              PtoIntSegQSeCruzanUnPto CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                      CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegB
              IdA = IdA + 1
            ElseIf (CDBY(IdB) <= YSegActivo) Then
              PtoIntSegQSeCruzanUnPto CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                      CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegB
              'IdA = IdA + 1
            Else
              IdB = IdB + 1
            End If
        End If
    End If

    If SegActual = SegB Then
        If CDBX(IdB) <= CDAX(IdA) Then
            'EL SGTE PUNTO ES DEL CONJ. DIFUSO 2
            YSegActivo = CoordYPtoCEnSegAB(CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                           CDBX(IdB), CDBY(IdB), Intersecta)
            If Not Intersecta Then
              IntroducirValorMatriz CDINTX(), CDBX(IdB), CDINTY(), CDBY(IdB)
              IdB = IdB + 1
            ElseIf (CDBY(IdB) < YSegActivo) Then
              IntroducirValorMatriz CDINTX(), CDBX(IdB), CDINTY(), CDBY(IdB)
              IdB = IdB + 1
            Else
              PtoIntSegQSeCruzanUnPto CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                      CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegA
              IdB = IdB + 1
            End If
        Else
            'EL SGTE PUNTO ES DEL CONJ. DIFUSO 1
            YSegActivo = CoordYPtoCEnSegAB(CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                           CDAX(IdA), CDAY(IdA), Intersecta)
            If Not Intersecta Then
              PtoIntSegQSeCruzanUnPto CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                      CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegA
              IdB = IdB + 1
            ElseIf CDAY(IdA) < YSegActivo Then
              PtoIntSegQSeCruzanUnPto CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                      CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegA
              'IdB = IdB + 1
            Else
              IdA = IdA + 1
            End If
        End If
    End If
    
  Loop
  
  If IdA = UBound(CDAX()) Then
    IntroducirValorMatriz CDINTX(), CDAX(UBound(CDAX())), CDINTY(), CDAY(UBound(CDAY()))
  Else
    IntroducirValorMatriz CDINTX(), CDBX(UBound(CDBX())), CDINTY(), CDBY(UBound(CDBY()))
  End If
  
End Sub

'**************************************************************************************************
'   PROCEDIMIENTO: UNION_SNORMA_MAXIMO()
'
'       OBJETIVO:
'
'**************************************************************************************************
Public Sub UNION_SNORMA_MAXIMO(CDAX() As Double, CDAY() As Double, CDBX() As Double, CDBY() As Double, _
                               CDINTX() As Double, CDINTY() As Double)

  Dim IdA As Integer, IdB As Integer
  Dim SegActual As ETSEGACTUAL
  Dim YSegActivo As Double
  Dim TempX As Double, TempY As Double
  Dim Intersecta As Boolean
  
  Erase CDINTX()
  Erase CDINTY()
  
  'HAY QUE COMPROBAR QUE LOS LIMITES PARA AMBOS CONJUNTOS SON LOS MISMO Y SI NO FUERA AS LA SGTE
  'FUNCIN LOS IGUALAR PARA QUE LOS PUNTOS INICIALES CDAX(0) = CDBX(0) & CDAX(ULTIMO) = CDBX(ULTIMO).
  IgualarLimitesVectores CDAX(), CDAY(), CDBX(), CDBY()
  
  'EMPEZAMOS POR EL SEGUNDO PTO YA QUE EL PRIMERO ES IGUAL PARA AMBOS CONJ.DIFUSOS (0,0)
  IdA = 1
  IdB = 1
  
  'EL PRIMER PUNTO SIEMPRE ES VLIDO
  IntroducirValorMatriz CDINTX(), CDAX(0), CDINTY(), CDAY(0)
  
  'EVALUACIN DEL PRIMER PUNTO
  If (CDAX(IdA) <= CDBX(IdB)) Then
    SegActual = SegA
  Else
    SegActual = SegB
  End If
  
  'SIGUIENTES PUNTOS
  Do While ((IdA < UBound(CDAX(), 1) And IdB < UBound(CDBX(), 1)))
    
    If SegActual = SegA Then
        If (CDAX(IdA) <= CDBX(IdB)) Then
            'EL SGTE PUNTO ES DEL CONJ. DIFUSO 1
            YSegActivo = CoordYPtoCEnSegAB(CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                           CDAX(IdA), CDAY(IdA), Intersecta)
            If Not Intersecta Then
              IntroducirValorMatriz CDINTX(), CDAX(IdA), CDINTY(), CDAY(IdA)
              IdA = IdA + 1
            ElseIf CDAY(IdA) > YSegActivo Then
              IntroducirValorMatriz CDINTX(), CDAX(IdA), CDINTY(), CDAY(IdA)
              IdA = IdA + 1
            Else
              PtoIntSegQSeCruzanUnPto CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                      CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegB
              IdA = IdA + 1
            End If
        Else
            'EL SGTE PUNTO ES DEL CONJ. DIFUSO 2
            YSegActivo = CoordYPtoCEnSegAB(CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                           CDBX(IdB), CDBY(IdB), Intersecta)
            If Not Intersecta Then
              PtoIntSegQSeCruzanUnPto CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                      CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegB
              IdA = IdA + 1
            ElseIf (CDBY(IdB) >= YSegActivo) Then
              PtoIntSegQSeCruzanUnPto CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                      CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegB
              'IdA = IdA + 1
            Else
              IdB = IdB + 1
            End If
        End If
    End If
    
    If SegActual = SegB Then
        If CDBX(IdB) <= CDAX(IdA) Then
            'EL SGTE PUNTO ES DEL CONJ. DIFUSO 2
            YSegActivo = CoordYPtoCEnSegAB(CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                           CDBX(IdB), CDBY(IdB), Intersecta)
            If Not Intersecta Then
              IntroducirValorMatriz CDINTX(), CDBX(IdB), CDINTY(), CDBY(IdB)
              IdB = IdB + 1
            ElseIf (CDBY(IdB) > YSegActivo) Then
              IntroducirValorMatriz CDINTX(), CDBX(IdB), CDINTY(), CDBY(IdB)
              IdB = IdB + 1
            Else
              PtoIntSegQSeCruzanUnPto CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                      CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegA
              IdB = IdB + 1
            End If
        Else
            'EL SGTE PUNTO ES DEL CONJ. DIFUSO 1
            YSegActivo = CoordYPtoCEnSegAB(CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), _
                                           CDAX(IdA), CDAY(IdA), Intersecta)
            If Not Intersecta Then
              PtoIntSegQSeCruzanUnPto CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                      CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegA
              IdB = IdB + 1
            ElseIf CDAY(IdA) > YSegActivo Then
              PtoIntSegQSeCruzanUnPto CDAX(IdA - 1), CDAY(IdA - 1), CDAX(IdA), CDAY(IdA), _
                                      CDBX(IdB - 1), CDBY(IdB - 1), CDBX(IdB), CDBY(IdB), TempX, TempY
              IntroducirValorMatriz CDINTX(), TempX, CDINTY(), TempY
              SegActual = SegA
              'IdB = IdB + 1
            Else
              IdA = IdA + 1
            End If
        End If
    End If
    
  Loop
  
  If IdA = UBound(CDAX()) Then
    ' Si se termina el  conj. A, entonces hay que introducir el resto de puntos de B que no hayan sido tratados an y el
    ' ltimo tratado tambin por eso lo de IdBoA -1 por que aunque haya sido tratado en el caso de conjuntos difusos
    ' separados, es decir, que no se tocan sus zonas de grado mayor que cero...
    For I = IdB - 1 To UBound(CDBX())
        IntroducirValorMatriz CDINTX(), CDBX(I), CDINTY(), CDBY(I)
    Next I
    
  Else
    For I = IdA - 1 To UBound(CDAX())
        IntroducirValorMatriz CDINTX(), CDAX(I), CDINTY(), CDAY(I)
    Next I
  End If
  
End Sub


