Attribute VB_Name = "FuzzySets"
'-------------------------------------------------------------------------------------------------------
'                                   ## MDULO DE CDIGO: FUZZYSETS.BAS ##
'
' OBJETIVO: Gestin y reestructuracin de los datos que definen a difusor y conjuntos difusos
'           para el tratamiento por parte de los procedimientos de clculo DIFUMINAR_ , DEFUZZIFICAR_ ...
'-------------------------------------------------------------------------------------------------------

'**************************************************************************************************
'   PROCEDIMIENTO: SPLINES_INPUT()
'
'       OBJETIVO:
'
'**************************************************************************************************
Public Sub SPLINES_INPUT(Vble As TEVARIABLE, IdVCrisp As Integer, IdConjDif As Integer, _
                         CoordXDif() As Double, CoordYDif() As Double, _
                         CoordXCDif() As Double, CoordYCDif() As Double)
                           
  Dim CoordXYDif() As Double, CoordXYCDif() As Double
  '1) SE OBTIENE LAS FUNCIONES POLINMICA DEFINIDAS A TROZOS (SPLINES_INPUT) DE DIFUSOR Y C.DIFUSO
  VectorPtosDifusor Vble, CoordXYDif(), IdVCrisp
  VectorPtosCDifuso Vble.ConjDif(IdConjDif), CoordXYCDif(), True, Vble.UnivDiscurso(0), Vble.UnivDiscurso(1)
  '2) SE DEVUELVEN LAS COORDX E Y SEPARADAS
  SepararCoordXY CoordXYDif(), CoordXDif(), CoordYDif()
  SepararCoordXY CoordXYCDif(), CoordXCDif(), CoordYCDif()
  
End Sub

'**************************************************************************************************
'   PROCEDIMIENTO: SPLINES_OUTPUT()
'
'       OBJETIVO:
'
'**************************************************************************************************
Public Sub SPLINES_OUTPUT(Vble As TSVARIABLE, IdConjDif As Integer, _
                          CoordXGradoAct() As Double, CoordYGradoAct() As Double, _
                          CoordXCDif() As Double, CoordYCDif() As Double)
                           
  Dim CoordXYGradoAct() As Double, CoordXYCDif() As Double
  '1) SE OBTIENE LAS FUNCIONES POLINMICA DEFINIDAS A TROZOS (SPLINES_OUTPUT) DEL
  '    CONJUNTO DIFUSO DE ALTURA GRADO DE ACTIVACIN ETIQUETA SALIDA Y C.DIFUSO.
  VectorPtosGradoAct Vble.ConjDif(IdConjDif).GACTIVACION_MAX, Vble.UnivDiscurso(0), Vble.UnivDiscurso(1), CoordXYGradoAct()
  VectorPtosCDifuso Vble.ConjDif(IdConjDif), CoordXYCDif(), True, Vble.UnivDiscurso(0), Vble.UnivDiscurso(1)
  '2) SE DEVUELVEN LAS COORDX E Y SEPARADAS
  SepararCoordXY CoordXYGradoAct(), CoordXGradoAct(), CoordYGradoAct()
  SepararCoordXY CoordXYCDif(), CoordXCDif(), CoordYCDif()
  
End Sub

'**************************************************************************************************
'   PROCEDIMIENTO: VectorPtosGradoAct()
'
'       OBJETIVO:
'
'**************************************************************************************************
Public Sub VectorPtosGradoAct(ByVal GACTIVACION As Double, ByVal MinUd As Double, ByVal MaxUd As Double, CoordXYGradoAct() As Double)

  ReDim CoordXYGradoAct(8)
  CoordXYGradoAct(0) = MinUd - EPSILON
  CoordXYGradoAct(1) = 0#
  CoordXYGradoAct(2) = MinUd
  CoordXYGradoAct(3) = GACTIVACION
  CoordXYGradoAct(4) = MaxUd
  CoordXYGradoAct(5) = GACTIVACION
  CoordXYGradoAct(6) = MaxUd + EPSILON
  CoordXYGradoAct(7) = 0#
  
End Sub

'**************************************************************************************************
'   PROCEDIMIENTO: VectorPtosDifusor()
'
'       OBJETIVO: Delvover el vector de puntos que forma la funcin polinmica a trozos
'                 representativa del difusor correspondiente a una variable de entrada.
'

'**************************************************************************************************
 Public Sub VectorPtosDifusor(VEntrada As TEVARIABLE, PBYE() As Double, Optional IdVCrisp As Integer = -1)
    
    'En caso de que se produzca un error en tiempo de ejecucin se ejecutar la instruccin siguiente
    On Error Resume Next
    Dim I As Integer, j As Integer, m As Integer, k As Integer
    Dim MSIDPEIZDA As Integer, MSIDPEDCHA As Integer, MSIDPEDIF As Integer, MSIDDIF As Integer
    Dim PREF As Double, VCrisp As Double
    Dim PEIZDA() As Double, PEDCHA() As Double
    Dim VE As TEVARIABLE
    ReDim PBYE(0)
    
    
    VE = VEntrada
    
    MSIDPEDIF = UBound(VE.Difusor.PExtendidos(), 1)
    If Err.Number = 9 Then
      Err.Clear
      MSIDPEDIF = 0
    End If
    'Se comprueba si por la llamada al procedimiento se quiere que se haga
    'el escalado a la variable de entrada. Si no es as tomar valor 0
    'de forma que escale la posicin del difusor.
    If IdVCrisp = -1 Then
      VCrisp = 0#
    Else
      
      VCrisp = VE.VCrisp(IdVCrisp)
      'Previamente hay que desplazar los puntos que definen al difusor entorno a su punto
       'medio (pref) que tomara el valor de partida 0.0 y a partir del cual los restantes
       'se rehubicaran manteniendo la distancia entre ellos. As posteriormente cuando
       'se sume el desplazamiento debido al vcrips de cada momento dichos puntos
       'pasarn a formar parte de la escala de la variable de entrada.
      
       PREF = (VE.Difusor.PBasicos(1) + VE.Difusor.PBasicos(2)) / 2
       If MSIDPEDIF = 0 Then
          GoTo SINPEXTDIFUSOR
       End If
       For I = 0 To MSIDPEDIF - 1 Step 2
         VE.Difusor.PExtendidos(I) = VE.Difusor.PExtendidos(I) - PREF
       Next I
SINPEXTDIFUSOR:
       VE.Difusor.PBasicos(0) = VE.Difusor.PBasicos(0) - PREF
       VE.Difusor.PBasicos(1) = VE.Difusor.PBasicos(1) - PREF
       VE.Difusor.PBasicos(2) = VE.Difusor.PBasicos(2) - PREF
       VE.Difusor.PBasicos(3) = VE.Difusor.PBasicos(3) - PREF
    
    End If
    
    
    If VE.Difusor.Tipo <> DifTrapecioExtendido Then
      GoTo MetSencillo
            
    Else
      If MSIDPEDIF = 0 Then
        GoTo MetSencillo
      End If
      'Se comprueba que por lo menos hay un parmetro extendido, es decir, VE.Difusor.PExtendidos contiene al menos (e1,he1)
      If MSIDPEDIF >= 1 Then
          m = 0
          For I = 0 To MSIDPEDIF - 1 Step 2
            'PARAMETRO EXTENDIDO DE LA IZDA
            If VE.Difusor.PExtendidos(I) < VE.Difusor.PBasicos(B) And VE.Difusor.PExtendidos(I) > VE.Difusor.PBasicos(A) Then
              'Si el parametro extendido es menor que el bsico (b) querr decir que corresponde a la parte izda y para ello se redimensiona
              'la matriz que los contendr a dos nuevos elementos, dicho parmetro posicionado segn el VCrisp y su altura correspondiente.
              If I = 0 Then
                ReDim PEIZDA(1)
              Else
                ReDim Preserve PEIZDA(UBound(PEIZDA(), 1) + 2)
              End If
              'Almacena (e)
              PEIZDA(I) = VE.Difusor.PExtendidos(I)
              'Almacenan (he)
              PEIZDA(I + 1) = VE.Difusor.PExtendidos(I + 1)
              m = I + 2
            'PARAMETRO EXTENDIDO DE LA DCHA
            ElseIf VE.Difusor.PExtendidos(I) > VE.Difusor.PBasicos(C) And VE.Difusor.PExtendidos(I) < VE.Difusor.PBasicos(D) Then
              'Si el parametro extendido es mayor que el bsico (c) querr decir que corresponde a la parte dcha y para ello se redimensiona
              'la matriz que los contendr a dos nuevos elementos, dicho parmetro y su altura correspondiente.
              If I = 0 Or (m = I) Then
                ReDim PEDCHA(1)
              Else
                ReDim Preserve PEDCHA(UBound(PEDCHA, 1) + 2)
              End If
              'Almacena (e)
              PEDCHA(I - m) = VE.Difusor.PExtendidos(I)
              'Almacenan (he)
              PEDCHA((I - m) + 1) = VE.Difusor.PExtendidos(I + 1)
            End If
          Next I
      End If
      'Si el ConjDif es Trapecio Extendido este va a contener los parametros bsicos y extendidos del ConjDif
      'de la siguiente forma PBYE = (Min,0,a,0,ei1,hei1,...,ein,hein,b,1,c,1,ed1,hed1,...,edm,hedm,d,0,Max,0).
      'Como mnimo contendr los bsicos en caso de que no existan parmetros extendidos.
      
      If IdVCrisp = -1 Then
        ReDim PBYE(1)
        'Almacena (a, 0)
        PBYE(0) = VE.Difusor.PBasicos(0) + VCrisp
        PBYE(1) = 0#
        j = 1
      Else
        'HAY QUE COMPROBAR SI EL PTO A AL SER ESCALADO AL UNIVERSO DE LA VARIABLE Y PARA EL VALOR CONCRETO DE
        'UN INSTANTE (VCRISP) NO ES INFERIOR AL VALOR MNIMO DEL UNIVERSO DE DISCURSO, ES DECIR, HAY QUE COMPROBAR
        'QUE SI EL DIFUSOR SE SALE POR LA IZDA Y EN DICHO CASO NO SE CONSIDERAR EL MIN COMO PTO A TENER EN CUENTA.
        If VE.Difusor.PBasicos(0) + VCrisp > VE.UnivDiscurso(0) Then
          ReDim PBYE(3)
          'Almacena (min, 0)
          PBYE(0) = VE.UnivDiscurso(0)
          PBYE(1) = 0#
          'Almacena (a, 0)
          PBYE(2) = VE.Difusor.PBasicos(0) + VCrisp
          PBYE(3) = 0#
          j = 3
        Else
          ReDim PBYE(1)
          'Almacena (a, 0)
          PBYE(0) = VE.Difusor.PBasicos(0) + VCrisp
          PBYE(1) = 0#
          j = 1
        End If
        
      End If
      
      Err.Clear
      MSIDPEIZDA = UBound(PEIZDA(), 1)
      If Err.Number = 9 Then
        Err.Clear
        MSIDPEIZDA = 0
      End If
      If MSIDPEIZDA >= 1 Then
        'HAY PARAMETROS EXTENDIDOS A LA IZDA
        j = j + 1
        For I = 0 To MSIDPEIZDA
          'Por cada nuevo elemento se redimensiona para contenerlo manteniendo los anteriores (Preserve)
          ReDim Preserve PBYE(UBound(PBYE, 1) + 1)
          If I Mod 2 = 0 Then 'SI EL ID ES PAR ESTAMOS EN POSICIONES DE LA COORDENADA ABCISAS
            PBYE(j + I) = PEIZDA(I) + VCrisp
          Else
            PBYE(j + I) = PEIZDA(I)
          End If
        Next I
        j = UBound(PBYE(), 1)
      End If
      
      'Almacenan (b,1,c,1) en su posicin tal que (Min,0,a,0,ei1,hei1,...,ein,hein,b,1,c,1) o (a,0,b,1,c,1)
      'si no existian parmetros del trapecio extendido en la izquierda.
      'Se redimensiona para contener estos 4 nuevos elementos
      ReDim Preserve PBYE(UBound(PBYE, 1) + 4)
      j = j + 1
      PBYE(j) = VE.Difusor.PBasicos(1) + VCrisp
      j = j + 1
      PBYE(j) = 1#
      j = j + 1
      PBYE(j) = VE.Difusor.PBasicos(2) + VCrisp
      j = j + 1
      PBYE(j) = 1#
      j = j + 1
        
      Err.Clear
      MSIDPEDCHA = UBound(PEDCHA(), 1)
      If Err.Number = 9 Then
        Err.Clear
        MSIDPEDCHA = 0
      End If
      If MSIDPEDCHA >= 1 Then
        'HAY PARAMETROS EXTENDIDOS A LA DCHA
        For I = 0 To MSIDPEDCHA
          'Por cada nuevo elemento se redimensiona para contenerlo manteniendo los anteriores (Preserve)
          ReDim Preserve PBYE(UBound(PBYE, 1) + 1)
          If I Mod 2 = 0 Then
            PBYE(j + I) = PEDCHA(I) + VCrisp
          Else
            PBYE(j + I) = PEDCHA(I)
          End If
        Next I
        j = UBound(PBYE(), 1) + 1
      End If
      
      'Por ltimo se almacena el parmetro bsico (d,0) y el mximo del universo de discurso (Max,0)
      If IdVCrisp = -1 Then
        ReDim Preserve PBYE(UBound(PBYE, 1) + 2)
        PBYE(j) = VE.Difusor.PBasicos(3) + VCrisp
        j = j + 1
        PBYE(j) = 0#
      Else
        'HAY QUE COMPROBAR SI EL PTO D AL SER ESCALADOS AL UNIVERSO DE LA VARIABLE Y PARA EL VALOR CONCRETO DE
        'UN INSTANTE (VCRISP) NO ES SUPERIOR AL VALOR MAXIMO DEL UNIVERSO DE DISCURSO, ES DECIR, HAY QUE COMPROBAR
        'QUE SI EL DIFUSOR SE SALE POR LA DERECHA Y EN DICHO CASO NO SE CONSIDERAR EL MAXIMO COMO PTO D TENER EN CUENTA.
        If VE.Difusor.PBasicos(3) + VCrisp < VE.UnivDiscurso(1) Then
          ReDim Preserve PBYE(UBound(PBYE, 1) + 4)
          PBYE(j) = VE.Difusor.PBasicos(3) + VCrisp
          j = j + 1
          PBYE(j) = 0#
          j = j + 1
          PBYE(j) = VE.UnivDiscurso(1)
          j = j + 1
          PBYE(j) = 0#
        Else
          ReDim Preserve PBYE(UBound(PBYE, 1) + 2)
          PBYE(j) = VE.Difusor.PBasicos(3) + VCrisp
          j = j + 1
          PBYE(j) = 0#
         End If

      End If
      
    End If
  
    Exit Sub

MetSencillo:
    
    If IdVCrisp = -1 Then
      ReDim PBYE(7)
      'PTO A
      PBYE(0) = VE.Difusor.PBasicos(0) + VCrisp
      PBYE(1) = 0#
      'PTO B
      PBYE(2) = VE.Difusor.PBasicos(1) + VCrisp
      PBYE(3) = 1#
      'PTO C
      PBYE(4) = VE.Difusor.PBasicos(2) + VCrisp
      PBYE(5) = 1#
      'PTO D
      PBYE(6) = VE.Difusor.PBasicos(3) + VCrisp
      PBYE(7) = 0#
    Else
      If VE.Difusor.PBasicos(0) + VCrisp > VE.UnivDiscurso(0) Then
        'Se dimensiona a doce posiciones
        ReDim PBYE(11)
        'MNIMO UNIV. DISCURSO
        PBYE(0) = VE.UnivDiscurso(0)
        PBYE(1) = 0#
        'PTO A
        PBYE(2) = VE.Difusor.PBasicos(0) + VCrisp
        PBYE(3) = 0#
        k = 4
      Else
        'Se dimensiona a nueve posiciones
        ReDim PBYE(9)
        'MNIMO UNIV. DISCURSO
        PBYE(0) = VE.Difusor.PBasicos(0) + VCrisp
        PBYE(1) = 0#
        k = 2
      End If
      
      'PTO B
      PBYE(k) = VE.Difusor.PBasicos(1) + VCrisp
      k = k + 1
      PBYE(k) = 1#
      k = k + 1
      'PTO C
      PBYE(k) = VE.Difusor.PBasicos(2) + VCrisp
      k = k + 1
      PBYE(k) = 1#
      k = k + 1
      
      If VE.Difusor.PBasicos(3) + VCrisp < VE.UnivDiscurso(1) Then
        'PTO D
        PBYE(k) = VE.Difusor.PBasicos(3) + VCrisp
        k = k + 1
        PBYE(k) = 0#
        k = k + 1
        'MAX. UNIV. DISCURSO
        PBYE(k) = VE.UnivDiscurso(1)
        k = k + 1
        PBYE(k) = 0#
        
      Else
        'MAX. UNIV. DISCURSO
        ReDim Preserve PBYE(7)
        PBYE(k) = VE.Difusor.PBasicos(3) + VCrisp
        k = k + 1
        PBYE(k) = 0#
        
      End If
    End If

 End Sub


'**************************************************************************************************
'   PROCEDIMIENTO: VectorPtosCDifuso()
'
'       OBJETIVO: Devolver el vector de puntos que forma la funcin polinmica a trozos
'                 representativa del conjunto difuso correspondiente a una variable de entrada.
'

'**************************************************************************************************
 Public Sub VectorPtosCDifuso(CDIFUSOSELECCIONADO As TCONJDIFUSO, PBYE() As Double, _
                              Optional MasPtosUnivDiscurso As Boolean = False, _
                              Optional MinUd As Double, Optional MaxUd As Double)
    
    'En caso de que se produzca un error en tiempo de ejecucin
    'se ejecutar la instruccin siguiente.
    On Error Resume Next
    Dim I As Integer, j As Integer, m As Integer, k As Integer
    Dim MSIDPEIZDA As Integer, MSIDPEDCHA As Integer, MSIDPECDIF As Integer, MSIDCDIF As Integer
    Dim PEIZDA() As Double, PEDCHA() As Double
    Dim CDIFUSO As TCONJDIFUSO
    ReDim PBYE(0)
    
    CDIFUSO = CDIFUSOSELECCIONADO
    
    MSIDPECDIF = UBound(CDIFUSO.PExtendidos(), 1)
    If Err.Number = 9 Then
      Err.Clear
      MSIDPECDIF = 0
    End If
   
    If CDIFUSO.Tipo <> TrapecioExtendido Then
      GoTo MetSencillo
            
    Else
      If MSIDPECDIF = 0 Then
        GoTo MetSencillo
      End If
      'Se comprueba que por lo menos hay un parmetro extendido, es decir, CDIFUSO. PExtendidos contiene al menos (e1,he1)
      If MSIDPECDIF >= 1 Then
          m = 0
          For I = 0 To MSIDPECDIF - 1 Step 2
            'PARAMETRO EXTENDIDO DE LA IZDA
            If CDIFUSO.PExtendidos(I) < CDIFUSO.PBasicos(B) And CDIFUSO.PExtendidos(I) > CDIFUSO.PBasicos(A) Then
              'Si el parametro extendido es menor que el bsico (b) querr decir que corresponde a la parte izda y para ello se redimensiona
              'la matriz que los contendr a dos nuevos elementos, dicho parmetro posicionado segn el VCrisp y su altura correspondiente.
              If I = 0 Then
                ReDim PEIZDA(1)
              Else
                ReDim Preserve PEIZDA(UBound(PEIZDA(), 1) + 2)
              End If
              'Almacena (e)
              PEIZDA(I) = CDIFUSO.PExtendidos(I)
              'Almacenan (he)
              PEIZDA(I + 1) = CDIFUSO.PExtendidos(I + 1)
              m = I + 2
            'PARAMETRO EXTENDIDO DE LA DCHA
            ElseIf CDIFUSO.PExtendidos(I) > CDIFUSO.PBasicos(C) And CDIFUSO.PExtendidos(I) < CDIFUSO.PBasicos(D) Then
              'Si el parametro extendido es mayor que el bsico (c) querr decir que corresponde a la parte dcha y para ello se redimensiona
              'la matriz que los contendr a dos nuevos elementos, dicho parmetro y su altura correspondiente.
              If I = 0 Or (m = I) Then
                ReDim PEDCHA(1)
              Else
                ReDim Preserve PEDCHA(UBound(PEDCHA, 1) + 2)
              End If
              'Almacena (e)
              PEDCHA(I - m) = CDIFUSO.PExtendidos(I)
              'Almacenan (he)
              PEDCHA((I - m) + 1) = CDIFUSO.PExtendidos(I + 1)
            End If
          Next I
      End If
      'Si el ConjDif es Trapecio Extendido este va a contener los parametros bsicos y extendidos del ConjDif
      'de la siguiente forma PBYE = (Min,0,a,0,ei1,hei1,...,ein,hein,b,1,c,1,ed1,hed1,...,edm,hedm,d,0,Max,0).
      'Como mnimo contendr los bsicos en caso de que no existan parmetros extendidos.
      
      If MasPtosUnivDiscurso Then
         ReDim PBYE(3)
        'Almacena (Min, 0)
        PBYE(0) = MinUd
        PBYE(1) = 0#
        'Almacena (a, 0)
        PBYE(2) = CDIFUSO.PBasicos(0)
        PBYE(3) = 0#
        j = 3
      Else
        ReDim PBYE(1)
        'Almacena (a, 0)
        PBYE(0) = CDIFUSO.PBasicos(0)
        PBYE(1) = 0#
        j = 1
      End If
      
      MSIDPEIZDA = UBound(PEIZDA(), 1)
      If Err.Number = 9 Then
        Err.Clear
        MSIDPEIZDA = 0
      End If
      If MSIDPEIZDA >= 1 Then
        'HAY PARAMETROS EXTENDIDOS A LA IZDA
        j = j + 1
        For I = 0 To MSIDPEIZDA
          'Por cada nuevo elemento se redimensiona para contenerlo manteniendo los anteriores (PreserCDIFUSO)
          ReDim Preserve PBYE(UBound(PBYE, 1) + 1)
          PBYE(j + I) = PEIZDA(I)
        Next I
        j = UBound(PBYE(), 1)
     End If
     
     'Almacenan (b,1,c,1) en su posicin tal que (Min,0,a,0,ei1,hei1,...,ein,hein,b,1,c,1) o (a,0,b,1,c,1)
     'si no existian parmetros del trapecio extendido en la izquierda.
     'Se redimensiona para contener estos 4 nuevos elementos
     ReDim Preserve PBYE(UBound(PBYE, 1) + 4)
     j = j + 1
     PBYE(j) = CDIFUSO.PBasicos(1)
     j = j + 1
     PBYE(j) = 1#
     j = j + 1
     PBYE(j) = CDIFUSO.PBasicos(2)
     j = j + 1
     PBYE(j) = 1#
     j = j + 1
         
      MSIDPEDCHA = UBound(PEDCHA(), 1)
      If Err.Number = 9 Then
        Err.Clear
        MSIDPEDCHA = 0
      End If
      If MSIDPEDCHA >= 1 Then
        'HAY PARAMETROS EXTENDIDOS A LA DCHA
        For I = 0 To MSIDPEDCHA
          ReDim Preserve PBYE(UBound(PBYE, 1) + 1)
          PBYE(j + I) = PEDCHA(I)
        Next I
        j = UBound(PBYE(), 1) + 1
      End If
      
      'Por ltimo se almacena el parmetro bsico (d,0).
      If MasPtosUnivDiscurso Then
        ReDim Preserve PBYE(UBound(PBYE, 1) + 4)
        PBYE(j) = CDIFUSO.PBasicos(3)
        j = j + 1
        PBYE(j) = 0#
        j = j + 1
        PBYE(j) = MaxUd
        j = j + 1
        PBYE(j) = 0#
      Else
        ReDim Preserve PBYE(UBound(PBYE, 1) + 2)
        PBYE(j) = CDIFUSO.PBasicos(3)
        j = j + 1
        PBYE(j) = 0#
      End If
      
    End If
    
    Exit Sub

MetSencillo:
    
    If MasPtosUnivDiscurso Then
      'Se dimensiona a doce posiciones
      ReDim PBYE(11)
      'MNIMO UNIV. DISCURSO
      PBYE(0) = MinUd
      PBYE(1) = 0#
      'PTO A
      PBYE(2) = CDIFUSO.PBasicos(0)
      PBYE(3) = 0#
      k = 4
        
      'PTO B
      PBYE(k) = CDIFUSO.PBasicos(1)
      k = k + 1
      PBYE(k) = 1#
      k = k + 1
      'PTO C
      PBYE(k) = CDIFUSO.PBasicos(2)
      k = k + 1
      PBYE(k) = 1#
      k = k + 1
      
      'PTO D
      PBYE(k) = CDIFUSO.PBasicos(3)
      k = k + 1
      PBYE(k) = 0#
      k = k + 1
      'MAX. UNIV. DISCURSO
      PBYE(k) = MaxUd
      k = k + 1
      PBYE(k) = 0#
        
    Else
      'Se dimensiona a doce posiciones
      ReDim PBYE(7)
      'PTO A
      PBYE(0) = CDIFUSO.PBasicos(0)
      PBYE(1) = 0#
      'PTO B
      PBYE(2) = CDIFUSO.PBasicos(1)
      PBYE(3) = 1#
      'PTO C
      PBYE(4) = CDIFUSO.PBasicos(2)
      PBYE(5) = 1#
      'PTO D
      PBYE(6) = CDIFUSO.PBasicos(3)
      PBYE(7) = 0#
    End If

 End Sub

